%{
#
# Parse::YYLex  pbyacc Ȥäʰץࡣ
# Copyright (c) 2009, Hiroyuki Ohsaki.
# All rights reserved.
#
# $Id: parse.y,v 1.4 2010/01/26 12:31:26 oosaki Exp $
#

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# ʸϷ̤¸륰Хѿ
our $tree;
%}

%token DIGIT
%right '+' '-'
%right '*' '/'

%%
line:		expr
		{ $tree = $1 };		# Ϸ̤ $tree 
	;

expr:		term
	|	'(' expr ')'
		{ $$ = $2; }
	|	expr '+' expr
		{ $$ = [$2, $1, $3]; }	# 黻ҡ黻1黻2 ƿ֤̾
	|	expr '-' expr
		{ $$ = [$2, $1, $3]; }
	|	expr '*' expr
		{ $$ = [$2, $1, $3]; }
	|	expr '/' expr
		{ $$ = [$2, $1, $3]; }
        ;
   
term:	        number			# ά $$ = $1 ˤʤ
	|	'+' number
		{ $$ = $2; }
	|	'-' number
		{ $$ = -$2; }
        ;

number:		DIGIT
	|	DIGIT number
		{ $$ = $1 . $2; }
	;

%%
